﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Controls.Primitives;

namespace Train
{
    /// <summary>
    /// Interaction logic for ConfigurationPlan.xaml
    /// </summary>
    public partial class ConfigurationPlan : Window
    {
        private Point[] p = new Point[2];
        private ObjectTyp newObjectTyp;
        private int drawStep;
        public Graphic2D Grafic;
        private ControlTemplate ct;
        public ConfigurationPlan()
        {
            InitializeComponent();
            Grafic = new Graphic2D(canvas);
            ct = (ControlTemplate)this.FindResource("DesignerItemTemplate");
        }
        public void ShowFormAndInput()
        {
            Show();
        }
        private void Button_LineClick(object sender, RoutedEventArgs e)
        {
            Grafic.State = GraficState.grfDraw;
            drawStep = 0;
            newObjectTyp = ObjectTyp.MyLine;
            Grafic.CreateNewLine(new Point(), new Point());
            canvas.CaptureMouse();
        }
        private void canvas_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            switch (Grafic.State)
            {
                case GraficState.grfNormal:
                case GraficState.grfSelect:
                    //pathTmp = Grafic.HitTest(e.GetPosition(canvas));                    
                    break;
                case GraficState.grfDraw:
                    for (int i = drawStep; i < 2; i++)
                    {
                        p[i] = e.GetPosition(canvas);
                    }
                    Grafic.DeleteLastElement();
                    switch (newObjectTyp)
                    {
                        case ObjectTyp.MyLine:
                            Grafic.CreateNewLine(p[0], p[1]);
                            break;
                        case ObjectTyp.MyEllipse:
                            Grafic.CreateNewEllipse(p[0], Math.Abs(p[1].X - p[0].X), Math.Abs(p[1].Y - p[0].Y));
                            break;
                    }
                    drawStep++;
                    break;
            }         
        }
        private void canvas_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            switch (Grafic.State)
            {
                case GraficState.grfNormal:
                    canvas.ReleaseMouseCapture();
                    break;
                case GraficState.grfDraw:
                    if (drawStep == 2)
                    {
                        Grafic.State = GraficState.grfNormal;
                        drawStep = 0;
                        p[0] = new Point(0, 0);
                        p[1] = new Point(0, 0);
                        canvas.ReleaseMouseCapture();
                        ContentControl cc = (ContentControl)canvas.Children[canvas.Children.Count - 1];
                        cc.Template = ct;
                    }
                    break;
                case GraficState.grfSelect:
                    canvas.ReleaseMouseCapture();
                    break;
                default:
                    break;
            }
        }
        private void canvas_MouseMove(object sender, MouseEventArgs e)
        {
            switch (Grafic.State)
            {
                case GraficState.grfNormal:
                    break;
                case GraficState.grfDraw:
                    Grafic.DeleteLastElement();
                    if (drawStep == 1)
                    {
                        p[drawStep] = e.GetPosition(canvas);
                    }
                    switch (newObjectTyp)
                    {
                        case ObjectTyp.MyLine:
                            Grafic.CreateNewLine(p[0], p[1]);
                            break;
                        case ObjectTyp.MyEllipse:
                            Grafic.CreateNewEllipse(p[0], Math.Abs(p[1].X - p[0].X), Math.Abs(p[1].Y - p[0].Y));
                            break;
                    }
                    break;
                case GraficState.grfSelect:
                    if (e.LeftButton == MouseButtonState.Pressed)
                    {
                    
                    }
                    break;
                default:
                    break;
            }
        }
    }
}
