﻿using System.IO;
using System.Windows;
using System.Windows.Input;
using Microsoft.Win32;

namespace Train
{
    /// <summary>
    /// Interaction logic for ConfigurationTrain.xaml
    /// </summary>
    public partial class ConfigurationTrain : Window
    {
        private Data data;
        public ConfigurationTrain()
        {
            InitializeComponent();
        }

        public void ShowFormAndInput(Data Daten)
        {
            data = Daten;
            ShowDialog();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            System.Windows.Data.CollectionViewSource dataItemViewSource = ((System.Windows.Data.CollectionViewSource)(this.FindResource("dataItemViewSource")));
            dataItemViewSource.Source = data.TrainData;
        }

        private void dataItemTrainDataGrid_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            // Anzeigen des Bildes
            try
            {
                string dir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName) + "\\icons\\";
                string fileName = ((DataItemTrain)dataItemGrid.SelectedValue).IconFileName;
                string pfad = dir + fileName;

                BitmapPreview preview = new BitmapPreview();
                if (File.Exists(pfad))
                {
                    preview.ShowFormAndInput(pfad);
                }
            }
            catch { }
        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "Daten|*.bmp";
            if (openFileDialog.ShowDialog() == true)
            {
                DataItemTrain item = ((DataItemTrain)dataItemGrid.SelectedValue);
                data.TrainData.Remove(item);
                item.IconFileName = System.IO.Path.GetFileName(openFileDialog.FileName);
                data.TrainData.Add(item);
                dataItemGrid.ItemsSource = data.TrainData;
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }
    }
}
